using System;
using System.Linq;
class Program
{
    static void Main()
    {
        string[] niz = Console.ReadLine().Split();
        long n = long.Parse(niz[0]);
        long q = long.Parse(niz[1]);
        long[] dani = new long[n];
        long[] pakovanja = new long[n];
        long[] pitanja = new long[q];
        for (long i = 0; i < n; i++)
        {
            string[] u = Console.ReadLine().Split();
            dani[i] = long.Parse(u[0]);
            pakovanja[i] = long.Parse(u[1]);
        }
        for (long i = 0; i < q; i++)
        {
            pitanja[i] = long.Parse(Console.ReadLine());
        }
        foreach (long i in pitanja)
        {
            long odg = 0;
            long c = 0;
            long trenutno = 0;
            for (long j = dani[0]; j <= i; j++)
            {
                if (pakovanja.Sum() < i)
                {
                    odg = pakovanja.Sum();
                    break;
                }
                if (j == dani[c])
                {
                    trenutno += pakovanja[c];
                    if (c < n - 1)
                    {
                        c++;
                    }
                }
                if (trenutno > 0)
                {
                    trenutno--;
                    odg++;
                }
            }
            Console.WriteLine(odg);
        }
    }
}